package org.opengroup.osdu.register.api;

import static org.junit.Assert.assertEquals;
import static org.mockito.Mockito.when;

import java.io.IOException;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.runners.MockitoJUnitRunner;
import org.opengroup.osdu.core.common.info.VersionInfoBuilder;
import org.opengroup.osdu.core.common.model.info.VersionInfo;

@RunWith(MockitoJUnitRunner.class)
public class InfoApiTest {

  @InjectMocks
  private InfoApi sut;

  @Mock
  private VersionInfoBuilder versionInfoBuilder;

  @Test
  public void should_return200_getVersionInfo() throws IOException {
    VersionInfo versionInfo = VersionInfo.builder()
        .groupId("group")
        .artifactId("artifact")
        .version("0.1.0")
        .buildTime("1000")
        .branch("master")
        .commitId("7777")
        .commitMessage("Merge commit")
        .build();
    when(versionInfoBuilder.buildVersionInfo()).thenReturn(versionInfo);
    VersionInfo response = this.sut.info();
    assertEquals(versionInfo, response);
  }
}
