/*
 * Copyright 2017-2020, Schlumberger
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.opengroup.osdu.register.utils;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.powermock.core.classloader.annotations.PrepareForTest;
import org.powermock.modules.junit4.PowerMockRunner;

import java.util.Objects;

@RunWith(PowerMockRunner.class)
@PrepareForTest({Preconditions.class})
public class PreconditionsTest {

    @Test(expected = IllegalArgumentException.class)
    public void should_return_error_when_argument_is_invalid(){
        Preconditions.checkArgument(null, Objects::nonNull, "value cannot be null");
    }

    @Test
    public void should_check_when_argument_is_valid(){
        Preconditions.checkArgument("", Objects::nonNull, "value cannot be null");
    }

    @Test
    public void should_check_null_empty_when_argument_is_valid(){
        Preconditions.checkNotNullOrEmpty("index", "value cannot be null");
    }

}
