/*
 * Copyright 2017-2020, Schlumberger
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.opengroup.osdu.register.util;

import com.sun.jersey.api.client.ClientResponse;

public abstract class RestDescriptor {
    private String arg = "";

    public String getArg() {
        return arg;
    }

    public abstract String getPath();

    public abstract String getHttpMethod();

    public abstract String getValidBody();

    public String getQuery() {
        return "";
    }

    public RestDescriptor() {
    }

    public ClientResponse runHttp(String arg, String accessToken) throws Exception {
        this.arg = arg;
        return TestUtils.sendHttp(getPath(), getHttpMethod(), accessToken, getValidBody(), getQuery());
    }

    public ClientResponse run(String arg, String token) throws Exception {
        this.arg = arg;
        return TestUtils.send(getPath(), getHttpMethod(), token, getValidBody(), getQuery());
    }

    public ClientResponse runWithCustomPayload(String arg, String body, String accessToken) throws Exception {
        this.arg = arg;
        return TestUtils.send(getPath(), getHttpMethod(), accessToken, body, getQuery());
    }

    public ClientResponse runOnCustomerTenant(String id, String token) throws Exception {
        this.arg = id;
        return TestUtils.send(getPath(), getHttpMethod(), token, getValidBody(), getQuery(), TestUtils.getCustomerTenantHeaders());
    }

    public ClientResponse runOptions(String id, String accessToken) throws Exception {
        this.arg = id;
        return TestUtils.send(getPath(), "OPTIONS", accessToken, "", "");
    }
}